class Content::Pipeline::Filters::Blockquote < Content::Pipeline::Filter
  XPaths = [
    ".//blockquote/p[1][starts-with(text(), 'By ')]",
    ".//blockquote/p[1][starts-with(text(), 'From ')]"
  ]

  add_filter({
    :blockquotes => :nokogiri
  })

  def blockquotes
    @str = @str.to_nokogiri_fragment
    @str.xpath(XPaths.join(" | ")).each do |v|
      v.replace(parse_blockquote(
        v.inner_html
      ))
    end
  end

  def parse_blockquote(text)
    text = text.each_line.to_a
    text[0] = <<-HTML
      <header class="cite">
        #{text[0]}
      </header>
      #{
        if text[1..-1].any?
          <<-HTML
            <p>
              #{text[1..-1].join(
                "\n"
              )}
            </p>
          HTML
        end
      }
    HTML
  end
end
