unless jruby?
  require "pygments"
end

class Content::Pipeline::Filters::Code < Content::Pipeline::Filter
  add_filter({
    :highlight => :nokogiri
  })

  Matcher = /<pre>(.+)<\/pre>/m
  Templates = {
    :wrap => '<figure class="highlight"><pre><code class="%s language-%s" ' \
      'data-programming-language="%s">%s</code></pre></figure>',
    :line => '<span class="line">%s</span>',
  }

  def initialize(*args)
    super(
      *args
    )
  end

  private
  def highlight
    @str = @str.to_nokogiri_fragment
    @str.search("pre > code").each do |node|
      lang = node[:class] || node.parent[:lang] || \
        @opts[:default] || "ruby"

      node.parent.replace(
        Templates[:wrap] % [
          lang, lang, lang, pygments(node.inner_text, lang)
        ]
      )
    end
  end

  private
  def pygments(str, lang)
    return str if jruby? || !Pygments::Lexer[lang]
    Pygments::Lexer[lang].highlight(str) =~ Matcher ? $1 : str
  end
end
