class Content::Pipeline::Filters::Links < Content::Pipeline::Filter
  HttpRegexp = /\A(\/\/|http:\/\/)/
  add_filter({
    :wrapper => :nokogiri
  })

  def wrapper
    @str = @str.to_nokogiri_fragment
    @str.xpath(".//a").each do |v|
      external(https(
        v
      ))
    end
  end

  def external(val)
    unless !@opts[:host] || val[:href] =~ \
        %r!https?://#{Regexp.escape(@opts[:host])}(?:\Z|/)!
      val[:target] = "_blank"
    end
  val
  end

  def https(val)
    val[:href] = val[:href].gsub(
      HttpRegexp, "https://"
    )
  val
  end
end
